.586
.MMX
.MODEL FLAT, STDCALL
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\masm32.inc

include Macros.inc
include Crypto_RC6.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

BUFF_SIZ	EQU (1 SHL 20)

DecFile		PROTO :DWORD, :DWORD
DecDir		PROTO :DWORD, :DWORD
EncFile		PROTO :DWORD, :DWORD, :DWORD
EncDir		PROTO :DWORD, :DWORD
Locate		PROTO :DWORD

.data

szEnterPass	db "Enter key: ", 0
szChoose	db "Choose an action:", 0Dh, 0Ah, "1. Encrypt a file", 0Dh, 0Ah, "2. Encrypt a directory", 0Dh, 0Ah, "3. Decrypt a file", 0Dh, 0Ah, "4. Decrypt a directory", 0Dh, 0Ah, "Choose 1-4: ", 0
szRetSiz	db 0Dh, 0Ah, "Size: ", 0
szRetProg	db " bytes", 0Dh, 0Ah, "Progress: ", 0
szEFName	db "Enter file name and path: ", 0
szEFOName	db "Enter output file name and path: ", 0
szEDir		db "Enter dirctory name: ", 0
szInvOpt	db "Invalid option", 0Dh, 0Ah, 0

szStar		db "*", 0
szPerc		db "%", 0
szBSlash	db "\", 0
szSpec1		db ".", 0
szSpec2		db "..", 0
szExt		db ".###", 0
szRet		db 0Dh, 0Ah, 0

a			dd 978698
b			dd 856875

.data?

pBuff		dd ?
szFileIn	db MAX_PATH dup (?)
szFileOut	db MAX_PATH dup (?)
szPass		db 35 dup (?)
szBuff		db 256 dup (?)
dwFSize		dd ?
RC6Key		RC6_KeyStruct <>

.code
start:

invoke GlobalAlloc, GMEM_FIXED, BUFF_SIZ
mov pBuff, eax

invoke StdOut, addr szEnterPass
invoke StdIn, addr szPass, 35
invoke StripLF, addr szPass
invoke lstrlen, addr szPass
lea edi, szPass[eax]
mov ecx, 32
sub ecx, eax
xor al, al
rep stosb
invoke ClearScreen
invoke RC6_SetKey, addr szPass, addr RC6Key

invoke StdOut, addr szChoose
invoke StdIn, addr szBuff, 5
invoke StripLF, addr szBuff
invoke atodw, addr szBuff
.if eax==1
	invoke StdOut, addr szEFName
	invoke StdIn, addr szFileIn, MAX_PATH
	invoke StripLF, addr szFileIn
	invoke StdOut, addr szEFOName
	invoke StdIn, addr szFileOut, MAX_PATH
	invoke StripLF, addr szFileOut
	invoke ClearScreen
	invoke EncFile, addr szFileIn, addr szFileOut, addr RC6Key
.elseif eax==2
	invoke StdOut, addr szEDir
	invoke StdIn, addr szFileIn, MAX_PATH
	invoke StripLF, addr szFileIn
	invoke ClearScreen
	invoke EncDir, addr szFileIn, addr RC6Key
.elseif eax==3
	invoke StdOut, addr szEFName
	invoke StdIn, addr szFileIn, MAX_PATH
	invoke StripLF, addr szFileIn
	invoke ClearScreen
	invoke DecFile, addr szFileIn, addr RC6Key
.elseif eax==4
	invoke StdOut, addr szEDir
	invoke StdIn, addr szFileIn, MAX_PATH
	invoke StripLF, addr szFileIn
	invoke ClearScreen
	invoke DecDir, addr szFileIn, addr RC6Key
.else
	invoke StdOut, addr szInvOpt
.endif

invoke StdOut, addr szRet

invoke GlobalFree, pBuff
invoke ExitProcess, 0

EncFile PROC pszFileIn:DWORD, pszFileOut:DWORD, pKey:DWORD
	LOCAL hFileIn:DWORD
	LOCAL hFileOut:DWORD
	LOCAL dwThisRead:DWORD
	LOCAL dwThisBSiz:DWORD
	LOCAL dwThisWrite:DWORD
	LOCAL dwDone:DWORD

	; =================
	; Create Both files
	; =================

	invoke CreateFile, pszFileIn, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL
	.if eax==INVALID_HANDLE_VALUE
		return FALSE
	.endif
	mov hFileIn, eax

	invoke CreateFile, pszFileOut, GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, NULL, NULL
	.if eax==INVALID_HANDLE_VALUE
		invoke CloseHandle, hFileIn
		return FALSE
	.endif
	mov hFileOut, eax
	
	; =========================================
	; Get the in file size and set counter to 0
	; =========================================
	
	invoke GetFileSize, hFileIn, NULL
	mov dwFSize, eax

	xor eax, eax
	mov dwDone, eax
	
	; ==================
	; Write info to file
	; ==================
	
	invoke lstrcpy, addr szBuff, pszFileIn

	invoke WriteFile, hFileOut, addr szBuff, 260, addr dwThisWrite, NULL
	
	.if eax==0
		invoke CloseHandle, hFileIn
		invoke CloseHandle, hFileOut

		return FALSE
	.endif	
	
	; ===========
	; Output info
	; ===========

	invoke StdOut, addr szRet
	invoke StdOut, pszFileIn
	invoke StdOut, addr szRetSiz
	invoke dwtoa, dwFSize, addr szBuff
	invoke StdOut, addr szBuff
	invoke StdOut, addr szRetProg
	invoke dwtoa, 0, addr szBuff
	invoke StdOut, addr szBuff
	invoke StdOut, addr szPerc
	
EncFile_Loop:

	; ==========
	; Read block
	; ==========
	
	invoke ReadFile, hFileIn, pBuff, BUFF_SIZ, addr dwThisRead, NULL
	
	.if eax==0
		invoke CloseHandle, hFileIn
		invoke CloseHandle, hFileOut

		return FALSE
	.endif
	
	; =============================
	; Check that there is some data
	; =============================
	
	mov eax, dwThisRead	
	or  eax, eax
	jnz @F
	
	invoke CloseHandle, hFileIn
	invoke CloseHandle, hFileOut

	return TRUE
@@:

	; ===============================
	; Moderate it to a multiple of 16
	; ===============================

	mov ecx, eax
	shr eax, 4
	and ecx, 15
	jz  @F
	inc eax
@@:
	shl eax, 4
	mov dwThisBSiz, eax
	
	; =======
	; Encrypt
	; =======
	
	invoke RC6_Encrypt, pBuff, pBuff, dwThisBSiz, pKey
	
	; ===============
	; Write to a file
	; ===============
	
	invoke WriteFile, hFileOut, pBuff, dwThisBSiz, addr dwThisWrite, NULL
	
	.if eax==0
		invoke CloseHandle, hFileIn
		invoke CloseHandle, hFileOut

		return FALSE
	.endif
	
	; ==================
	; Check write was OK
	; ==================
	
	mov eax, dwThisBSiz
	cmp eax, dwThisWrite
	je @F

	invoke CloseHandle, hFileIn
	invoke CloseHandle, hFileOut

	return TRUE
@@:
	
	; =================
	; Increment counter
	; =================
	
	mov eax, dwThisRead
	add dwDone, eax
	
	; ========================
	; Get percentage & display
	; ========================
	
	invoke Locate, 10
	mov eax, dwDone
	mov ecx, 100
	mul ecx
	div dwFSize
	invoke dwtoa, eax, addr szBuff
	invoke StdOut, addr szBuff
	invoke StdOut, addr szPerc
	
	; =============
	; Check for end
	; =============
	
	mov eax, dwThisRead
	cmp eax, BUFF_SIZ
	je EncFile_Loop
	
	; ====
	; Exit
	; ====
	
	invoke CloseHandle, hFileIn
	invoke CloseHandle, hFileOut

	return TRUE
EncFile ENDP

EncDir PROC pszSrc:DWORD, pKey:DWORD
	LOCAL szPath[MAX_PATH]:BYTE
	LOCAL szPath2[MAX_PATH]:BYTE
	LOCAL wfdFile:WIN32_FIND_DATA
	LOCAL hSearch:DWORD
	LOCAL dwCur:DWORD
	
	; ==============
	; Get first file
	; ==============
	
	invoke lstrcpy, addr szPath, pszSrc
	invoke lstrcat, addr szPath, addr szStar
	invoke FindFirstFile, addr szPath, addr wfdFile
	
	.if eax==INVALID_HANDLE_VALUE
		return
	.endif
	
	mov hSearch, eax
	
	xor eax, eax
	mov dwCur, eax

EncDir_Loop:

	; =====================
	; Is it a dir or a file
	; =====================
	
	invoke lstrcmp, addr wfdFile.cFileName, addr szSpec1
	.if eax!=0
		invoke lstrcmp, addr wfdFile.cFileName, addr szSpec2
		.if eax!=0
			.if wfdFile.dwFileAttributes==FILE_ATTRIBUTE_DIRECTORY
				invoke lstrcpy, addr szPath, pszSrc
				invoke lstrcat, addr szPath, addr wfdFile.cFileName
				invoke lstrcat, addr szPath, addr szBSlash
				
				invoke EncDir,  addr szPath, pKey
			.else
				invoke dwtoa, dwCur, addr szPath
				invoke lstrcpy, addr szPath2, pszSrc
				invoke lstrcat, addr szPath2, addr szPath
				invoke lstrcat, addr szPath2, addr szExt
				
				invoke lstrcpy, addr szPath, pszSrc
				invoke lstrcat, addr szPath, addr wfdFile.cFileName
				
				invoke EncFile, addr szPath, addr szPath2, pKey
				invoke StdOut,  addr szRet
				
				invoke DeleteFile, addr szPath
				
				inc dwCur
			.endif
		.endif
	.endif
	
	; =============
	; Get next file
	; =============
	
	invoke FindNextFile, hSearch, addr wfdFile
	
	.if eax==0
		invoke FindClose, hSearch
		return
	.endif
	
	jmp EncDir_Loop
EncDir ENDP

DecFile PROC pszFileIn:DWORD, pKey:DWORD
	LOCAL hFileIn:DWORD
	LOCAL hFileOut:DWORD
	LOCAL dwThisRead:DWORD
	LOCAL dwThisBSiz:DWORD
	LOCAL dwThisWrite:DWORD
	LOCAL dwDone:DWORD
	LOCAL szPath[MAX_PATH]:BYTE

	; ===========
	; Create file
	; ===========

	invoke CreateFile, pszFileIn, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL
	
	.if eax==INVALID_HANDLE_VALUE
		return FALSE
	.endif
	
	mov hFileIn, eax

	; =================
	; Get file name etc
	; =================

	invoke ReadFile, hFileIn, addr szBuff, 260, addr dwThisRead, NULL
	
	.if eax==0
		invoke CloseHandle, hFileIn

		return FALSE
	.endif
	
	; =========
	; Save name
	; =========
	
	invoke lstrcpy, addr szPath, addr szBuff

	; ===========
	; Create file
	; ===========

	invoke CreateFile, addr szPath, GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, NULL, NULL
	
	.if eax==INVALID_HANDLE_VALUE
		invoke CloseHandle, hFileIn
		
		return FALSE
	.endif
	
	mov hFileOut, eax
	
	; ================
	; Set counter to 0
	; ================
	
	xor eax, eax
	mov dwDone, eax
	
	; ===========
	; Output info
	; ===========

	invoke StdOut, addr szRet
	invoke StdOut, addr szPath
	invoke StdOut, addr szRetSiz
	invoke dwtoa, dwFSize, addr szBuff
	invoke StdOut, addr szBuff
	invoke StdOut, addr szRetProg
	invoke dwtoa, 0, addr szBuff
	invoke StdOut, addr szBuff
	invoke StdOut, addr szPerc
	
DecFile_Loop:

	; ==========
	; Read block
	; ==========
	
	invoke ReadFile, hFileIn, pBuff, BUFF_SIZ, addr dwThisRead, NULL
	
	.if eax==0
		invoke CloseHandle, hFileIn
		invoke CloseHandle, hFileOut

		return FALSE
	.endif
	
	; =============================
	; Check that there is some data
	; =============================
	
	mov eax, dwThisRead	
	or  eax, eax
	jnz @F
	
	invoke CloseHandle, hFileIn
	invoke CloseHandle, hFileOut

	return TRUE
@@:

	; =======
	; Decrypt
	; =======
	
	invoke RC6_Decrypt, pBuff, pBuff, dwThisRead, pKey
	
	; =================
	; Increment counter
	; =================
	
	;dwDone = dwThisRead + dwDone
	;if (dwDone > dwFSize) {
	;	dwThisRead -= dwDone - dwFSize
	;	dwDone = dwFSize
	;}
	
	mov eax, dwThisRead
	add eax, dwDone
	cmp eax, dwFSize
	jna @F
	mov ecx, eax
	sub ecx, dwFSize
	sub dwThisRead, ecx
	mov eax, dwFSize
@@:
	mov dwDone, eax
	
	; ===============
	; Write to a file
	; ===============
	
	invoke WriteFile, hFileOut, pBuff, dwThisRead, addr dwThisWrite, NULL
	
	.if eax==0
		invoke CloseHandle, hFileIn
		invoke CloseHandle, hFileOut

		return FALSE
	.endif
	
	; ==================
	; Check write was OK
	; ==================
	
	mov eax, dwThisRead
	cmp eax, dwThisWrite
	je @F

	invoke CloseHandle, hFileIn
	invoke CloseHandle, hFileOut

	return TRUE
@@:
	
	; ========================
	; Get percentage & display
	; ========================
	
	invoke Locate, 10
	mov eax, dwDone
	mov ecx, 100
	mul ecx
	div dwFSize
	invoke dwtoa, eax, addr szBuff
	invoke StdOut, addr szBuff
	invoke StdOut, addr szPerc
	
	; =============
	; Check for end
	; =============
	
	mov eax, dwThisRead
	cmp eax, dwFSize
	jne DecFile_Loop
	
	; ====
	; Exit
	; ====
	
	invoke CloseHandle, hFileIn
	invoke CloseHandle, hFileOut

	return TRUE
DecFile ENDP

DecDir PROC pszSrc:DWORD, pKey:DWORD
	LOCAL szPath[MAX_PATH]:BYTE
	LOCAL szPath2[MAX_PATH]:BYTE
	LOCAL wfdFile:WIN32_FIND_DATA
	LOCAL hSearch:DWORD
	LOCAL dwCur:DWORD
	
	; ==============
	; Get first file
	; ==============
	
	invoke lstrcpy, addr szPath, pszSrc
	invoke lstrcat, addr szPath, addr szStar
	invoke FindFirstFile, addr szPath, addr wfdFile
	
	.if eax==INVALID_HANDLE_VALUE
		return
	.endif
	
	mov hSearch, eax
	
	xor eax, eax
	mov dwCur, eax

DecDir_Loop:

	; =====================
	; Is it a dir or a file
	; =====================
	
	invoke lstrcmp, addr wfdFile.cFileName, addr szSpec1
	.if eax!=0
		invoke lstrcmp, addr wfdFile.cFileName, addr szSpec2
		.if eax!=0
			.if wfdFile.dwFileAttributes==FILE_ATTRIBUTE_DIRECTORY
				invoke lstrcpy, addr szPath, pszSrc
				invoke lstrcat, addr szPath, addr wfdFile.cFileName
				invoke lstrcat, addr szPath, addr szBSlash
				
				invoke DecDir,  addr szPath, pKey
			.else
				invoke dwtoa, dwCur, addr szPath
				invoke lstrcpy, addr szPath2, pszSrc
				invoke lstrcat, addr szPath2, addr szPath
				invoke lstrcat, addr szPath2, addr szExt
				
				invoke DecFile, addr szPath2, pKey
				invoke StdOut,  addr szRet
				
				invoke DeleteFile, addr szPath2
				
				inc dwCur
			.endif
		.endif
	.endif
	
	; =============
	; Get next file
	; =============
	
	invoke FindNextFile, hSearch, addr wfdFile
	
	.if eax==0
		invoke FindClose, hSearch
		return
	.endif
	
	jmp DecDir_Loop
DecDir ENDP

Locate PROC x:DWORD
    LOCAL hOutPut:DWORD
    LOCAL csbiCur:CONSOLE_SCREEN_BUFFER_INFO

    invoke GetStdHandle, STD_OUTPUT_HANDLE
    mov hOutPut, eax
    
	invoke GetConsoleScreenBufferInfo, hOutPut, addr csbiCur
	
    mov  ecx, x
    mov  ax, csbiCur.dwCursorPosition.y
    shl  eax, 16
    mov  ax, cx
	
	invoke SetConsoleCursorPosition, hOutPut, eax

	ret
Locate ENDP

end start























