.386
.MODEL FLAT, STDCALL
option casemap:none

include \masm32\include\windows.inc

include Macros.inc
include Crypto_RC6.inc

RC6_EncBlk	PROTO :DWORD, :DWORD
RC6_DecBlk	PROTO :DWORD, :DWORD

.data?

ll		dd 9 dup (?)
l_key	RC6_KeyStruct <>

.code

RC6_SetKey PROC in_key:DWORD, pKeyStruct:DWORD
	LOCAL a:DWORD
	LOCAL b:DWORD
	LOCAL i:DWORD
	LOCAL j:DWORD
	
	; l_key[0] = 0xB7E15163;
	; for(i=1;i<44;i++) l_key[i] = l_key[i-1] + 0x9e3779b9;

	; for(i=0;i<8;i++) l_key[i] = in_key[i]

	; for(i=0;i<7;i++) ll[i] = 0;
	
	; for(c=a=b=i=j=0;c<132;c++) {
	;     a        = rol((l_key[i] + a + b), 3);
	;     b       += a;
	;     b        = rol((ll[j] + b), (b & 0xFF));
	;     l_key[i] = a;
	;     ll[j]    = b;
	;     
	;     if (++i == 43) i = 0;
	;     if (++j == 7 ) j = 0;
	; }

	pushad
	
	; l_key[0] = 0xB7E15163;
	; for(i=1;i<44;i++) l_key[i] = l_key[i-1] + 0x9e3779b9;

	mov edi, pKeyStruct
	mov dword ptr [edi], 0B7E15163h
	xor ecx, ecx
	inc ecx
RC6_Setkey_cpy:
	mov eax, [edi + (ecx * 4) - 4]
	add eax, 09e3779b9h
	mov [edi + (ecx * 4)], eax
	inc ecx
	cmp ecx, 44
	jb  RC6_Setkey_cpy

	; for(i=0;i<8;i++) l_key[i] = in_key[i]

	xor ecx, ecx
	mov esi, in_key
	mov edx, 8
RC6_Setkey_cpy1:
	mov eax, [esi + (ecx * 4)]
	mov [edi + (ecx * 4)], eax
	inc ecx
	cmp ecx, edx
	jb  RC6_Setkey_cpy1
	
	; for(i=0;i<7;i++) ll[i] = 0;
	
	mov edi, offset ll
	xor eax, eax
	mov ecx, 9
	rep stosd

	; for(c=a=b=i=j=0;c<132;c++) {
	
	mov esi, offset ll
	dec edx
	xor ecx, ecx
	mov a, ecx
	mov b, ecx
	mov i, ecx
	mov j, ecx
RC6_Setkey_cpy2:
	push ecx
	
	; a  = rol((l_key[i] + a + b), 3)

	mov ebx, i
	mov eax, [edi + (ebx * 4)]	
	add eax, a
	add eax, b
	rol eax, 3
	mov a, eax

	; b += a

	add b, eax
	
	; b  = rol((ll[j] + b), (b & 0xFF))

	mov ebx, j
	mov eax, [esi + (ebx * 4)]
	add eax, b
	mov ecx, b
	rol eax, cl
	mov b, eax
	
	; l_key[i] = a

	mov eax, a
	mov ebx, i
	mov [edi + (ebx * 4)], eax

	; ll[j] = b
	
	mov eax, b
	mov ebx, j
	mov [esi + (ebx * 4)], eax
	
	; if(++i == 43) i = 0;
	
	mov eax, i
	inc eax
	cmp eax, 43
	jnz @F
	xor eax, eax
@@:
	mov i, eax
	
	; if(++j == 7) j = 0;
	
	mov eax, j
	inc eax
	cmp eax, edx
	jnz @F
	xor eax, eax
@@:
	mov j, eax

	; }

	pop ecx
	inc ecx
	cmp ecx, 132
	jb  RC6_Setkey_cpy2
	mov eax, edi
	
	popad
	
	ret
RC6_SetKey ENDP

RC6_DecBlk PROC in_blk2:DWORD, out_blk2:DWORD

	; d = in_blk[3]
	; c = in_blk[2] - l_key[43]
	; b = in_blk[1]
	; a = in_blk[0] - l_key[42]
	
	; cur = 40

	; do {
	;     a <- d <- c <- b <- a
	;     u = rol(d*(d+d+1),5)
	;     t = rol(b*(b+b+1),5)
	;     c = ror((c - l_key[cur + 1]), t) ^ u
	;     a = ror((a - l_key[cur]), u) ^ t
	;     cur -= 2
	; } while (cur != 0);

	; out_blk[3] = d - l_key[1]
	; out_blk[2] = c
	; out_blk[1] = b - l_key[0]
	; out_blk[0] = a
	
	push ebp
	mov esi,out_blk2
	push    esi
	mov edi,in_blk2
	mov esi,offset l_key
	
	; d = in_blk[3]
	; c = in_blk[2] - l_key[43]
	; b = in_blk[1]
	; a = in_blk[0] - l_key[42]

	mov edx,[edi+12]
	mov ecx,[edi+8]
	sub ecx,[esi+(43*4)]
	mov ebx,[edi+4]
	mov eax,[edi]
	sub eax,[esi+(42*4)]

	; cur = 40

	lea ebp,[esi+(40*4)]
	
	; do {

RC6_DecBlk_loop:

	;     a <- d <- c <- b <- a

	push    edx
	mov edx,ecx
	mov ecx,ebx
	mov ebx,eax
	pop eax
	
	;     u = rol(d*(d+d+1),5)

	lea esi,[edx+edx+1]
	imul    esi,edx
	rol esi,5
	
	;     t = rol(b*(b+b+1),5)

	lea edi,[ebx+ebx+1]
	imul    edi,ebx
	rol edi,5
	
	;     c = ror((c - l_key[cur + 1]), t) ^ u

	push    eax
	xchg    ecx,eax
	mov ecx,edi
	sub eax,[ebp+4]
	ror eax,cl
	xor eax,esi
	xchg    ecx,eax
	pop eax
	
	;     a = ror((a - l_key[cur]), u) ^ t

	push    ecx
	mov ecx,esi
	sub eax,[ebp]
	ror eax,cl
	xor eax,edi
	pop ecx
	
	;     cur -= 2
	; } while (cur != 0);
	
	sub ebp, 8
	cmp ebp, offset l_key
	jnz RC6_DecBlk_loop
	
	; out_blk[3] = d - l_key[1]
	; out_blk[2] = c
	; out_blk[1] = b - l_key[0]
	; out_blk[0] = a

	mov esi,ebp
	pop edi
	sub edx,[esi+4]
	mov [edi+12],edx
	mov [edi+8],ecx
	sub ebx,[esi]
	mov [edi+4],ebx
	mov [edi],eax
	
	pop ebp
	ret
RC6_DecBlk ENDP

RC6_EncBlk PROC in_block:DWORD, out_block:DWORD
	push ebp
	mov esi,out_block
	mov edi,in_block
	push    esi
	mov esi, offset l_key
	mov eax,[edi]       ;a=in_block[0]
	mov ebx,[edi+4]
	add ebx,[esi]       ;b=in_block[1]+l_key[0]
	mov ecx,[edi+8]     ;c=in_block[2]
	mov edx,[edi+12]
	add edx,[esi+4]     ;d=in_block[3]+l_key[1]
	lea ebp,[esi+8]
RC6_EncBlk_loop:
	lea esi,[edx+edx+1]
	imul    esi,edx
	rol esi,5           ;u=rol(d*(d+d+1),5)
	
	lea edi,[ebx+ebx+1]
	imul    edi,ebx
	rol edi,5           ;t=rol(b*(b+b+1),5)
	
	push    ecx
	mov ecx,esi
	xor eax,edi
	rol eax,cl
	add eax,[ebp]       ;a=rol(a^t,u)+l_key[i]
	pop ecx
	
	push    eax
	xchg    ecx,eax
	mov ecx,edi
	xor eax,esi
	rol eax,cl
	add eax,[ebp+4]     ;c=rol(c^u,t)+l_key[i+1]
	xchg    ecx,eax
	pop eax
	
	push    eax
	mov eax,ebx
	mov ebx,ecx
	mov ecx,edx
	pop edx
	add ebp, 8
	cmp ebp,(offset l_key+(42*4))
	jnz RC6_EncBlk_loop
	
	pop edi
	mov esi,offset l_key
	add eax,[esi+(42*4)]
	mov [edi],eax
	mov [edi+4],ebx
	add ecx,[esi+(43*4)]
	mov [edi+8],ecx
	mov [edi+12],edx
	
	pop ebp
	ret
RC6_EncBlk ENDP

RC6_Encrypt PROC pDest:DWORD, pSrc:DWORD, dwLen:DWORD, pKeyStruct:DWORD
	pushad
	
	mov esi, pKeyStruct
	mov edi, offset l_key
	mov ecx, 45
	rep movsd

	mov ecx, dwLen
	or  ecx, ecx
	jnz @F
	popad
	ret
@@:
	mov edx, ecx
	shr ecx, 4
	and edx, 15
	jz  @F
	inc ecx
@@:
	mov dwLen, ecx
	
RC6_Encrypt_loop:
	invoke RC6_EncBlk, pSrc, pDest
	add pDest, 16
	add pSrc, 16
	sub dwLen, 1
	jnz RC6_Encrypt_loop
	
	popad
	ret
RC6_Encrypt ENDP

RC6_Decrypt PROC pDest:DWORD, pSrc:DWORD, dwLen:DWORD, pKeyStruct:DWORD
	pushad
	
	mov esi, pKeyStruct
	mov edi, offset l_key
	mov ecx, 45
	rep movsd

	mov ecx, dwLen
	or  ecx, ecx
	jnz @F
	popad
	ret
@@:
	mov edx, ecx
	shr ecx, 4
	and edx, 15
	jz  @F
	inc ecx
@@:
	mov dwLen, ecx
	
RC6_Decrypt_loop:
	invoke RC6_DecBlk, pSrc, pDest
	add pDest, 16
	add pSrc, 16
	sub dwLen, 1
	jnz RC6_Decrypt_loop
	
	popad
	ret
RC6_Decrypt ENDP

end